Package org.apache.sis.referencing.datum

## Class DefaultEngineeringDatum

- Object
- - FormattableObject
  - - AbstractIdentifiedObject
    - - AbstractDatum
      - - DefaultEngineeringDatum

- All Implemented Interfaces:
    `Serializable`, `Deprecable`, `LenientComparable`, `Datum`, `EngineeringDatum`, `IdentifiedObject`

      public class DefaultEngineeringDatum
      extends AbstractDatum
      implements EngineeringDatum

  Defines the origin of an engineering coordinate reference system. An engineering datum is used in a region around that origin. This origin can be fixed with respect to the earth (such as a defined point at a construction site), or be a defined point on a moving vehicle (such as on a ship or satellite).
  Immutability and thread safety
  This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.
  Since:
    0.4
  See Also:
    `DefaultEngineeringCRS`, `GeodeticAuthorityFactory​.createEngineeringDatum(String)`, Serialized Form

  Defined in the `sis-referencing` module

- - ### Field Summary

    - ### Fields inherited from class AbstractIdentifiedObject

      `DEPRECATED_KEY, LOCALE_KEY`

    - ### Fields inherited from interface Datum

      `ANCHOR_POINT_KEY, DOMAIN_OF_VALIDITY_KEY, REALIZATION_EPOCH_KEY, SCOPE_KEY`

    - ### Fields inherited from interface IdentifiedObject

      `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `DefaultEngineeringDatum​(Map<String,​?> properties)` | Creates an engineering datum from the given properties.
    `protected` | `DefaultEngineeringDatum​(EngineeringDatum datum)` | Creates a new datum with the same values than the specified one.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultEngineeringDatum` | `castOrCopy​(EngineeringDatum object)` | Returns a SIS datum implementation with the same values than the given arbitrary implementation.
    `protected String` | `formatTo​(Formatter formatter)` | Formats this datum as a Well Known Text `EngineeringDatum[…]` element.
    `Class<? extends EngineeringDatum>` | `getInterface()` | Returns the GeoAPI interface implemented by this class.

    - ### Methods inherited from class AbstractDatum

      `castOrCopy, computeHashCode, equals, getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope, isHeuristicMatchForName`

    - ### Methods inherited from class AbstractIdentifiedObject

      `castOrCopy, equals, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated`

    - ### Methods inherited from class FormattableObject

      `print, toString, toString, toWKT`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface Datum

      `getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope`

    - ### Methods inherited from interface IdentifiedObject

      `getAlias, getIdentifiers, getName, getRemarks, toWKT`

- - ### Constructor Detail

    - #### DefaultEngineeringDatum

          public DefaultEngineeringDatum​(Map<String,​?> properties)

      Creates an engineering datum from the given properties. The properties map is given unchanged to the super-class constructor. The following table is a reminder of main (not all) properties:

      Recognized properties (non exhaustive list)
      Property name | Value type | Returned by
      --- | --- | ---
      "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
      "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
      "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
      "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
      "anchorPoint" | `InternationalString` or `String` | `AbstractDatum.getAnchorPoint()`
      "realizationEpoch" | `Date` | `AbstractDatum.getRealizationEpoch()`
      "domainOfValidity" | `Extent` | `AbstractDatum.getDomainOfValidity()`
      "scope" | `InternationalString` or `String` | `AbstractDatum.getScope()`

      Parameters:
        `properties` - the properties to be given to the identified object.
      See Also:
        `GeodeticObjectFactory​.createEngineeringDatum(Map)`

    - #### DefaultEngineeringDatum

          protected DefaultEngineeringDatum​(EngineeringDatum datum)

      Creates a new datum with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

      This constructor performs a shallow copy, i.e. the properties are not cloned.

      Parameters:
        `datum` - the datum to copy.
      See Also:
        `castOrCopy(EngineeringDatum)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultEngineeringDatum castOrCopy​(EngineeringDatum object)

      Returns a SIS datum implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getInterface

          public Class<? extends EngineeringDatum> getInterface()

      Returns the GeoAPI interface implemented by this class. The SIS implementation returns `EngineeringDatum​.class`.
      Note for implementers: Subclasses usually do not need to override this method since GeoAPI does not define `EngineeringDatum` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
      Overrides:
        `getInterface` in class `AbstractDatum`
      Returns:
        `EngineeringDatum​.class` or a user-defined sub-interface.

    - #### formatTo

          protected String formatTo​(Formatter formatter)

      Formats this datum as a Well Known Text `EngineeringDatum[…]` element.
      Overrides:
        `formatTo` in class `AbstractDatum`
      Parameters:
        `formatter` - the formatter where to format the inner content of this WKT element.
      Returns:
        `"EngineeringDatum"` (WKT 2) or `"Local_Datum"` (WKT 1).
      See Also:
        WKT 2 specification §11.2